package com.ejie.ab39a.control;

import com.ejie.ab39a.service.ProvinciaService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JQGridRequestDto;
import com.ejie.x38.dto.JQGridResponseDto;
import java.util.List;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import com.ejie.ab39a.model.Provincia;

/**
 * ProvinciaController.
 * 
 *  
 */

@Controller
@RequestMapping(value = "/provincia")

public class ProvinciaController {

	private static final Logger logger = LoggerFactory.getLogger(ProvinciaController.class);

	@Autowired
	private ProvinciaService provinciaService;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idProvincia
	 *            String idProvincia
	 * @param descOf
	 *            String descOf
	 * @param idAutonomia
	 *            String idAutonomia
	 * @return Provincia Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idProvincia}/{descOf}/{idAutonomia}", method = RequestMethod.GET)
	public @ResponseBody Provincia get(@PathVariable String idProvincia, @PathVariable String descOf,
			@PathVariable String idAutonomia) {
		Provincia provincia = new Provincia();
		provincia.setIdProvincia(idProvincia);
		provincia.setDescOf(descOf);
		provincia.setIdAutonomia(idAutonomia);
		provincia = this.provinciaService.find(provincia);
		ProvinciaController.logger.info("[GET - findBy_PK] : Obtener Provincia por PK");
		return provincia;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterProvincia
	 *            Provincia Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Provincia> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(value = "getAllProvincia", method = RequestMethod.GET)
	public @ResponseBody List<Provincia> getAll(@ModelAttribute Provincia filterProvincia) {
		ProvinciaController.logger.info("[GET - find_ALL] : Obtener Provincia por filtro");
		return this.provinciaService.findAll(filterProvincia, null);
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterProvincia
	 *            Provincia Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<Provincia> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(value = "getAllProvinciaNavIp", method = RequestMethod.GET)
	public @ResponseBody List<Provincia> getAllProv(@ModelAttribute Provincia filterProvincia) {
		ProvinciaController.logger.info("[GET - find_ALL] : Obtener Provincia por filtro");
		return this.provinciaService.findAllNavIp(filterProvincia, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param provincia
	 *            Provincia Bean que contiene la informacion a modificar.
	 * @return Provincia Bean resultante de la modificacion.
	 */
	@RequestMapping(method = RequestMethod.PUT)
	public @ResponseBody Provincia edit(@RequestBody Provincia provincia) {
		Provincia provinciaAux = this.provinciaService.update(provincia);
		ProvinciaController.logger.info("[PUT] : Provincia actualizado correctamente");
		return provinciaAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param provincia
	 *            Provincia Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return Provincia Bean resultante del proceso de creacion.
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody Provincia add(@RequestBody Provincia provincia) {
		Provincia provinciaAux = this.provinciaService.add(provincia);
		ProvinciaController.logger.info("[POST] : Provincia insertado correctamente");
		return provinciaAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idProvincia
	 *            String idProvincia
	 * @param descOf
	 *            String descOf
	 * @param idAutonomia
	 *            String Identificador del objeto que se desea eliminar.
	 * @return Provincia Bean eliminado.
	 */
	@RequestMapping(value = "/{idProvincia}/{descOf}/{idAutonomia}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Provincia remove(@PathVariable String idProvincia, @PathVariable String descOf,
			@PathVariable String idAutonomia) {
		Provincia provincia = new Provincia();
		provincia.setIdProvincia(idProvincia);
		provincia.setDescOf(descOf);
		provincia.setIdAutonomia(idAutonomia);
		this.provinciaService.remove(provincia);
		ProvinciaController.logger.info("[DELETE] : Provincia borrado correctamente");
		return provincia;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit() {
		ProvinciaController.logger.info("[GET - View] : provincia");
		return "provincia";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterProvincia
	 *            Provincia Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return JQGridResponseDto<Provincia> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody JQGridResponseDto<Provincia> filter(
			@RequestJsonBody(param = "filter") Provincia filterProvincia,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ProvinciaController.logger.info("[POST - filter] : Obtener Provincias");
		return this.provinciaService.filter(filterProvincia, jqGridRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterProvincia
	 *            Provincia Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param jqGridRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") Provincia filterProvincia,
			@RequestJsonBody JQGridRequestDto jqGridRequestDto) {
		ProvinciaController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples Provincias");
		this.provinciaService.removeMultiple(filterProvincia, jqGridRequestDto, false);
		ProvinciaController.logger.info("All entities correctly deleted!");

		return jqGridRequestDto.getMultiselection().getSelectedIds();
	}
}
